/*************************************
 * Phil Carns    Nov 99   Parl Lab
 * Test code for pvfsd kernel communication
 * This one writes a request into the device file
 ***************************************/

/* these three are included to make the types in ll_pvfs.h work */
#include <stdint.h>
#include <inttypes.h>
#include <time.h>

#include <sys/time.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include "../ll_pvfs.h"


int main(int argc, char **argv){

	struct pvfs_upcall *putreq = NULL;
	int devfile = -1;
	int req_sz = sizeof(struct pvfs_upcall);
	int read_sz = 0;
	fd_set readfds;
	struct timeval tv;

	if(argc != 1){
		printf("dumbass.\n");
		exit(-1);
	}

	putreq = (struct pvfs_upcall*)malloc(sizeof(struct pvfs_upcall));
	if(!putreq){
		perror("malloc");
		exit(-1);
	}

	devfile = open("/dev/pvfsd", O_RDONLY);
	if(devfile < 0){
		perror("open");
		exit(-1);
	}

	/* we want to select on the device before trying to read it... */
	FD_ZERO(&readfds);
	FD_SET(devfile, &readfds);
	tv.tv_sec = 20;
	tv.tv_usec = 0;
	if((select((devfile+1), &readfds, NULL, NULL, &tv)) > 0){
		if(FD_ISSET(devfile, &readfds)){
			read_sz = read(devfile, putreq, req_sz);
			if((read_sz!=0)&&(read_sz<req_sz)){
				perror("read");
				close(devfile);
				exit(-1);
			}
			else if(read_sz==0){
				printf("No data available.\n");
				close(devfile);
				return(0);
			}

			if(putreq->magic != PVFS_UPCALL_MAGIC){
				printf("Bad magic.\n");
			}
			printf("Recieved number: %d\n", putreq->seq);
		}
	}

	close(devfile);

	return(0);
}



